"use strict";
exports.__esModule = true;
var common_1 = require("@angular/common");
var chai_1 = require("chai");
var mocha_1 = require("mocha");
var json_pipe_1 = require("./json.pipe");
mocha_1.describe('Safety', function () {
    mocha_1.it('should throw when using normal Json pipe for circular structures', function () {
        var o = {};
        o.a = o;
        var pipe = new common_1.JsonPipe();
        var fn = function () {
            pipe.transform(o);
        };
        chai_1.expect(fn).to["throw"](TypeError);
    });
    mocha_1.it('should not throw when using safe json pipe on circular structure', function () {
        var o = {};
        o.a = o;
        var pipe = new json_pipe_1.SafeJsonPipe();
        var outcome = '';
        var fn = function () {
            outcome = pipe.transform(o);
        };
        chai_1.expect(fn).not.to["throw"](TypeError);
        // Should contain the keyword "Circular"
        fn();
        chai_1.expect(outcome).to.contain('Circular');
    });
});
