(function (factory) {
    if (typeof module === 'object' && typeof module.exports === 'object') {
        var v = factory(require, exports); if (v !== undefined) module.exports = v;
    }
    else if (typeof define === 'function' && define.amd) {
        define(["require", "exports", "@angular/core", "./safe.util.umd"], factory);
    }
})(function (require, exports) {
    "use strict";
    var core_1 = require("@angular/core");
    var safe_util_1 = require("./safe.util.umd");
    var PrettyJsonPipe = (function () {
        function PrettyJsonPipe() {
        }
        PrettyJsonPipe.prototype.transform = function (obj, spaces) {
            if (spaces === void 0) { spaces = 2; }
            return this._syntaxHighlight(obj, safe_util_1.serializer(), spaces);
        };
        PrettyJsonPipe.prototype._syntaxHighlight = function (json, serializer, spacing) {
            if (json === undefined) {
                return '<span class="undefined"></span>';
            }
            // Credits to the accepted answer here http://stackoverflow.com/questions/4810841/how-can-i-pretty-print-json-using-javascript
            if (typeof json !== "string") {
                json = JSON.stringify(json, serializer, spacing);
            }
            json = json.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
            return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
                var cls = "number";
                if (/^"/.test(match)) {
                    if (/:$/.test(match)) {
                        cls = "key";
                    }
                    else {
                        cls = "string";
                    }
                }
                else if (/true|false/.test(match)) {
                    cls = "boolean";
                }
                else if (/null/.test(match)) {
                    cls = "null";
                }
                return "<span class=\"" + cls + "\">" + match + "</span>";
            });
        };
        PrettyJsonPipe.decorators = [
            { type: core_1.Pipe, args: [{
                        name: "prettyjson",
                        pure: false
                    },] },
        ];
        /** @nocollapse */
        PrettyJsonPipe.ctorParameters = function () { return []; };
        return PrettyJsonPipe;
    }());
    exports.PrettyJsonPipe = PrettyJsonPipe;
});
//# sourceMappingURL=prettyjson.pipe.js.map